<?php

namespace Taxus\Picea;

use Picea\Compiler\Context;
use Taxus\Taxus;

class Extension implements \Picea\Extension\Extension
{
    protected Taxus $taxus;

    public function __construct(Context $context, Taxus $taxus)
    {
        $this->register($context);

        $this->taxus = $taxus;
    }

    public function register(Context $context) : void
    {
        $context->pushFunction("taxus", [ $this, 'taxus' ]);
        $context->pushFunction("taxus_has", [ $this, 'taxusHas' ]);
    }

    public function parse(\Picea\Compiler\Context &$context, ?string $arguments, string $token, array $options = []) : string
    {
        return "";
    }

    public function taxus(string $name, ...$arguments) : bool
    {
        return $this->taxus->granted($name, ...$arguments);
    }

    public function taxusHas(string $name) : bool
    {
        return $this->taxus->hasPrivilege($name);
    }
}
